#ifndef s11n_NODESPACE_HPP_INCLUDED
#define s11n_NODESPACE_HPP_INCLUDED 1

#include <qobject.h>
#include <s11n.net/s11n/s11nlite.hpp>
#include "node_util.hpp"

namespace s11n { namespace qt {

        class NodeSpace : public QObject
        {
                Q_OBJECT;
        public:
                typedef s11nlite::node_type node_t;
                NodeSpace( node_t * n ) : m_tree(n)
                {

                }

                virtual ~NodeSpace()
                {
                        delete this->m_tree.root();
                }

                node_t * root()
                {
                        return this->m_tree.root();
                }
        private:
                s11n::util::node_tree<node_t> m_tree;
        };


} } // namespace s11n::qt


#endif // s11n_NODESPACE_HPP_INCLUDED
